/*************************************************************************/
/***                                                                   ***/
/**                               ALGO.C                                **/
/***                                                                   ***/
/*************************************************************************/
#include <windows.h>
#include <string.h>
#include <stdio.h>
#include <malloc.h>
#include <dos.h>
#include <ctype.h>
#include <time.h>
#include "ctl3d.h"
#include "algo.h"

/*************************************************************************/
/***                                                                   ***/
/**                             Variables                               **/
/***                                                                   ***/
/*************************************************************************/
short cxClient, cyClient;
int Tallest;
BOOL NewRandom = TRUE;
HCURSOR hArrow, hHour;
HDC TempDC = NULL;
int BarsNum = MAXBARSNUM, CurrentColor, Swaps, Compares;
BAR Bars[MAXBARSNUM], TempBars[MAXBARSNUM], PrevBars[MAXBARSNUM];
RECT PageRect = { 0, 1000, 1000, 0 };
RECT DataRect = { 50, 50, 950, 850 };
RESULT Selection = { "Selection", ( float ) 0.0, 0, 0, FALSE };
RESULT Insertion = { "Insertion", ( float ) 0.0, 0, 0, FALSE };
RESULT Bubble = { "Bubble", ( float ) 0.0, 0, 0, FALSE };
RESULT Shell = { "Shell", ( float ) 0.0 , 0, 0, FALSE };
RESULT Count = { "Distribution counting", ( float ) 0.0, 0, 0, FALSE };

/*************************************************************************/
/***                                                                   ***/
/**                      DoClassRegistration                            **/
/***                                                                   ***/
/*************************************************************************/
BOOL DoClassRegistration( HINSTANCE hInstance )
{
	WNDCLASS wndclass;           

	memset( &wndclass, 0x00, sizeof( WNDCLASS ) );                           
	wndclass.style = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc = MainWindowProc;
	wndclass.cbClsExtra = 0;
	wndclass.cbWndExtra = 0;
	wndclass.hInstance = hInstance;
	wndclass.hIcon = LoadIcon( NULL, IDI_APPLICATION );
	wndclass.hCursor = LoadCursor( NULL, IDC_ARROW );
	wndclass.hbrBackground = ( HBRUSH )( COLOR_WINDOW + 1 );
	wndclass.lpszMenuName = MAKEINTRESOURCE( IDR_MENU );
	wndclass.lpszClassName = "Sorting";
	return RegisterClass( &wndclass );
}
           
/*************************************************************************/
/***                                                                   ***/
/**                           InitInstance                              **/
/***                                                                   ***/
/*************************************************************************/
BOOL InitInstance( HANDLE hInstance, int nCmdShow )
{
    hAppInst = hInstance;   
    Ctl3dRegister( hInstance );
    hMainWnd = CreateWindow( "Sorting", "Sorting example",
						WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT,
						CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL );
    if( !hMainWnd ) 
	{	
		Ctl3dUnregister( hInstance );
		return 0;
	}
    ShowWindow( hMainWnd, nCmdShow );
    UpdateWindow( hMainWnd );
    return 1;
}

/*************************************************************************/
/***                                                                   ***/
/**                             WinMain                                 **/
/***                                                                   ***/
/*************************************************************************/
int FAR PASCAL WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
    MSG Message;

    if( !hPrevInstance && !DoClassRegistration( hInstance ) )
        return 0;
    if( !InitInstance( hInstance, nCmdShow ) )
        return 0;
    while( GetMessage( &Message, NULL, 0, 0 ) )
    {
        TranslateMessage( &Message );
        DispatchMessage( &Message );
    }                          
    Ctl3dUnregister( hInstance );
    return Message.wParam;
}
 
/*************************************************************************/
/***                                                                   ***/
/**                          MainWindowProc                             **/
/***                                                                   ***/
/*************************************************************************/
long FAR PASCAL __export MainWindowProc( HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam )
{
	HMENU hMenu;
	
	switch( Msg ) 
	{
		case WM_CREATE:
			Ctl3dAutoSubclass( hAppInst );
	        hArrow = LoadCursor( NULL, IDC_ARROW );
	        hHour = LoadCursor( NULL, IDC_WAIT );
	        SetRandomBarHeights();
	        return 0;
		case WM_PAINT: 
        	DisplayBars( hWnd );
        	return 0;
		case WM_SYSCOLORCHANGE:
			Ctl3dColorChange();
			break;                  
		case WM_COMMAND:
		{
			hMenu = GetMenu( hWnd );
        	switch( wParam ) 
        	{
	            case IDM_SELECT:
	            {
	                DLGPROC lpResultProc;
	                
	                InitSort( hWnd );
	                SelectionSort();
	                EndSort( hWnd );
	                lpResultProc = MakeProcInstance( ( FARPROC ) ResultProc, hAppInst );
	                DialogBoxParam( hAppInst, "Result", hWnd, lpResultProc, ( LPARAM ) &Selection );
	                FreeProcInstance( lpResultProc );
	                return 0;
	            }
	            case IDM_INSERT:
	            {
	                DLGPROC lpResultProc;
	                
	                InitSort( hWnd );
	                InsertionSort();
	                EndSort( hWnd );
	                lpResultProc = MakeProcInstance( ( FARPROC ) ResultProc, hAppInst );
	                DialogBoxParam( hAppInst, "Result", hWnd, lpResultProc, ( LPARAM ) &Insertion );
	                FreeProcInstance( lpResultProc );
	                return 0;
	            }
	            case IDM_BUBBLE:
	            {
	                DLGPROC lpResultProc;
	                
	                InitSort( hWnd );
	                BubbleSort();
	                EndSort( hWnd );
	                lpResultProc = MakeProcInstance( ( FARPROC ) ResultProc, hAppInst );
	                DialogBoxParam( hAppInst, "Result", hWnd, lpResultProc, ( LPARAM ) &Bubble );
	                FreeProcInstance( lpResultProc );
	                return 0;
	            }
	            case IDM_SHELL:
	            {
	                DLGPROC lpResultProc;
	                
	                InitSort( hWnd );
	                ShellSort();
	                EndSort( hWnd );
	                lpResultProc = MakeProcInstance( ( FARPROC ) ResultProc, hAppInst );
	                DialogBoxParam( hAppInst, "Result", hWnd, lpResultProc, ( LPARAM ) &Shell );
	                FreeProcInstance( lpResultProc );
	                return 0;
	            }
	            case IDM_COUNT:
	            {
	                DLGPROC lpResultProc;
	                
	                InitSort( hWnd );
	                CountSort();
	                EndSort( hWnd );
	                lpResultProc = MakeProcInstance( ( FARPROC ) ResultProc, hAppInst );
	                DialogBoxParam( hAppInst, "Result", hWnd, lpResultProc, ( LPARAM ) &Count );
	                FreeProcInstance( lpResultProc );
	                return 0;
	            }
	            case IDM_NEWRANDOM: 
	                SetRandomBarHeights();
	                NewRandom = TRUE; 
	                Selection.Done = FALSE;
	                Insertion.Done = FALSE;
	                Bubble.Done = FALSE;
	                Shell.Done = FALSE;
	                Count.Done = FALSE;
	                InvalidateRect( hWnd, NULL, TRUE );
	                return 0;
	            case IDM_SORTED: 
	                SetSortedBarHeights();
	                NewRandom = TRUE; 
	                Selection.Done = FALSE;
	                Insertion.Done = FALSE;
	                Bubble.Done = FALSE;
	                Shell.Done = FALSE;
	                Count.Done = FALSE;
	                InvalidateRect( hWnd, NULL, TRUE );
	                return 0;
	            case IDM_INVERSE: 
	                SetInverseBarHeights();
	                NewRandom = TRUE; 
	                Selection.Done = FALSE;
	                Insertion.Done = FALSE;
	                Bubble.Done = FALSE;
	                Shell.Done = FALSE;
	                Count.Done = FALSE;
	                InvalidateRect( hWnd, NULL, TRUE );
	                return 0;
	            case IDM_RESULTS:
	            {
	                DLGPROC lpResultsProc;
	                
	                lpResultsProc = MakeProcInstance( ( FARPROC ) ResultsProc, hAppInst );
	                
	                DialogBox( hAppInst, "Results", hWnd, lpResultsProc );
	                FreeProcInstance( lpResultsProc );
	                return 0;
	            }
	            case IDM_ABOUT:
				{
					DLGPROC lpAboutProc;
						
					lpAboutProc = ( DLGPROC ) MakeProcInstance( ( FARPROC ) AboutProc, hAppInst );
					DialogBox( hAppInst, "HELPABOUT", hWnd, lpAboutProc );
					FreeProcInstance( lpAboutProc );
					break;
				}
	            return 0;
	            default:
	                return ( DefWindowProc( hWnd, Msg, wParam, lParam ) );
        	} 
    	} 
		case WM_DESTROY :
			PostQuitMessage( 0 );
			return 0;
		default:
			return DefWindowProc( hWnd, Msg, wParam, lParam );
	}
	return 0;
}              

/*************************************************************************/
/***                                                                   ***/
/**                              AboutProc                              **/
/***                                                                   ***/
/*************************************************************************/
LRESULT _export  FAR PASCAL	AboutProc( HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam )
{
	switch( Msg )
	{
		case WM_COMMAND:
			if( wParam == IDOK || wParam == IDCANCEL ) 
			{
				EndDialog( hDlg, TRUE );
				return TRUE;
			}
			break;
	}
	return FALSE; 
}

/*************************************************************************/
/***                                                                   ***/
/**                            GetRandomValue                           **/
/***                                                                   ***/
/*************************************************************************/
int GetRandomValue( int Min, int Max )
{
	return ( rand() % ( Max - Min + 1 ) ) + Min;
}

/*************************************************************************/
/***                                                                   ***/
/**                             SetBarColor                             **/
/***                                                                   ***/
/*************************************************************************/
COLORREF SetBarColor()
{
    CurrentColor++;
    CurrentColor %= MAXBARSNUM;
    return RGB( ( CurrentColor & 1 ) ? 255 : 0, 
    			( CurrentColor & 2 ) ? 255 : 0, 
    			( CurrentColor & 4 ) ? 255 : 0 );
}

/*************************************************************************/
/***                                                                   ***/
/**                         SetRandomBarHeights                         **/
/***                                                                   ***/
/*************************************************************************/
void SetRandomBarHeights()
{
	int Numbers[MAXBARSNUM], i, RandIndex, MaxIndex, Length;
	
	srand( ( unsigned ) time( NULL ) );
	for( i = 0; i < BarsNum; i++ )
		Numbers[i] = i + 1;
	MaxIndex = BarsNum - 1;
	CurrentColor = 0;
	Tallest = 0;
	for( i = 0; i < BarsNum; i++ )
	{
		RandIndex = GetRandomValue( 0, MaxIndex );
		Length = Numbers[RandIndex];
		Numbers[RandIndex] = Numbers[MaxIndex];
		MaxIndex--;
		if( Length > Tallest ) 
			Tallest = Length;
		Bars[i].Length = Length;
		Bars[i].Color = SetBarColor();
	}
	for( i = 0; i < BarsNum; i++ )
		PrevBars[i] = TempBars[i] = Bars[i];
}

/*************************************************************************/
/***                                                                   ***/
/**                         SetSortedBarHeights                         **/
/***                                                                   ***/
/*************************************************************************/
void SetSortedBarHeights()
{
    int i;

   	CurrentColor = 0;
    for( i = 0; i < BarsNum; i++ )
    {
        Bars[i].Length = TempBars[i].Length = PrevBars[i].Length = i + 1;
        Bars[i].Color = SetBarColor();
    }
}

/*************************************************************************/
/***                                                                   ***/
/**                         SetInverseBarHeights                        **/
/***                                                                   ***/
/*************************************************************************/
void SetInverseBarHeights()
{
    int i;

   	CurrentColor = 0;
    for( i = 0; i < BarsNum; i++ )
    {
        Bars[i].Length = TempBars[i].Length = PrevBars[i].Length = MAXBARSNUM - i;
        Bars[i].Color = SetBarColor();
    }
}

/*************************************************************************/
/***                                                                   ***/
/**                         InitPrevBarHeights                          **/
/***                                                                   ***/
/*************************************************************************/
void InitPrevBarHeights( HWND hWnd )
{
    int i;

    for( i = 0; i < BarsNum; i++ )
        Bars[i] = TempBars[i] = PrevBars[i];
    DisplayBars( hWnd );
}


/*************************************************************************/
/***                                                                   ***/
/**                             InitSort                                **/
/***                                                                   ***/
/*************************************************************************/
void InitSort( HWND hWnd )
{
    if( NewRandom )  
        NewRandom = FALSE;
    else                  
        InitPrevBarHeights( hWnd ); 
    TempDC = GetDC( hWnd );
    SetMapMode( TempDC, MM_ANISOTROPIC );
    SetWindowExt( TempDC, PageRect.right, PageRect.top );
    SetViewportExt( TempDC, cxClient, -cyClient ); 
    SetViewportOrg( TempDC, 0, cyClient );
    SetCursor( hHour );
}

/*************************************************************************/
/***                                                                   ***/
/**                              EndSort                                **/
/***                                                                   ***/
/*************************************************************************/
void EndSort(HWND hWnd)
{
    ReleaseDC( hWnd, TempDC );
    TempDC = NULL;
    SetCursor( hArrow );
}

/*************************************************************************/
/***                                                                   ***/
/**                            DisplayBars                              **/
/***                                                                   ***/
/*************************************************************************/
void DisplayBars( HWND hWnd )
{
    HDC hDC;     
    PAINTSTRUCT ps;
    float Fraction;
    short Width, i, CurrentHeight, NewHeight;
    COLORREF Color;
    RECT BarRect;
    HPEN hWhitePen, hOldPen;
    HBRUSH hNewBrush, hOldBrush, hNewBarBrush, hOldBarBrush;

    InvalidateRect( hWnd, NULL, TRUE );
    hDC = BeginPaint( hWnd, &ps );
    cxClient = ps.rcPaint.right - ps.rcPaint.left;
    cyClient = ps.rcPaint.bottom - ps.rcPaint.top;
    SetMapMode( hDC, MM_ANISOTROPIC );
    SetWindowExt( hDC, PageRect.right, PageRect.top );
    SetViewportExt( hDC, cxClient, -cyClient );
    SetViewportOrg( hDC, 0, cyClient );
    hWhitePen = CreatePen( PS_SOLID, 1, RGB( 255, 255, 255 ) );
    hOldPen = SelectObject( hDC, hWhitePen );
    Rectangle( hDC, DataRect.left, DataRect.top, DataRect.right, DataRect.bottom );
    SelectObject( hDC, hOldPen );
    DeleteObject( hWhitePen );
    hNewBrush = CreateSolidBrush( RGB( 0, 0, 0 ) );
    hOldBrush = SelectObject( hDC, hNewBrush );
    Width = ( short ) ( ( DataRect.right - DataRect.left ) / BarsNum );
    for( i = 0; i < BarsNum; i++ )
    {
        NewHeight = Bars[i].Length;
        Color = Bars[i].Color;
        Fraction = ( float ) NewHeight / ( float ) Tallest;
        CurrentHeight = ( short ) ( Fraction * ( DataRect.bottom - DataRect.top ) );
        BarRect.left = DataRect.left + ( Width * i );
        BarRect.top = CurrentHeight + DataRect.top;
        BarRect.right = DataRect.left + Width * ( i + 1 );
        BarRect.bottom = BarRect.top - CurrentHeight;
        hNewBarBrush = CreateSolidBrush( Color );
        hOldBarBrush =  SelectObject( hDC, hNewBarBrush );
        Rectangle( hDC, BarRect.left, BarRect.top, BarRect.right, BarRect.bottom );
        SelectObject( hDC, hOldBarBrush );
        DeleteObject( hNewBarBrush );
    }
    SelectObject( hDC, hOldBrush );
    DeleteObject( hNewBrush );
    EndPaint( hWnd, &ps );
}

/*************************************************************************/
/***                                                                   ***/
/**                              Wait                                   **/
/***                                                                   ***/
/*************************************************************************/
void Wait()
{
    clock_t WaitInterval;

    WaitInterval = 10L + clock();
    while( WaitInterval >= clock() );
}

/*************************************************************************/
/***                                                                   ***/
/**                             DrawBar                                 **/
/***                                                                   ***/
/*************************************************************************/
void DrawBar( int Bar )
{
    RECT BarRect;
    HPEN hWhitePen, hOldPen;
    HBRUSH hWhiteBrush, hOldBrush, hBarBrush;
    float Fraction;
    short CurrentHeight, Width;

    Width = ( short ) ( ( DataRect.right  - DataRect.left ) / BarsNum );
    Fraction = ( float ) TempBars[Bar].Length / ( float ) Tallest;
    CurrentHeight = ( short ) ( Fraction * ( DataRect.bottom - DataRect.top ) );
    BarRect.left = DataRect.left + ( Width * Bar );
    BarRect.top = CurrentHeight + DataRect.top;
    BarRect.right = DataRect.left + Width * ( Bar + 1 );
    BarRect.bottom = BarRect.top - CurrentHeight;
    hWhitePen = CreatePen( PS_SOLID, 1, RGB(  255, 255, 255 ) );
    hOldPen = SelectObject( TempDC, hWhitePen );
    hWhiteBrush = CreateSolidBrush( RGB( 255, 255, 255 ) );
    hOldBrush = SelectObject( TempDC, hWhiteBrush );
    Rectangle( TempDC, BarRect.left, BarRect.top, BarRect.right, BarRect.bottom );
    SelectObject( TempDC, hOldPen );
    DeleteObject( hWhitePen );
    SelectObject( TempDC, hOldBrush );
    DeleteObject( hWhiteBrush );
    Fraction = ( float ) Bars[Bar].Length / ( float ) Tallest;
    CurrentHeight = ( short ) ( Fraction * ( DataRect.bottom - DataRect.top ) );
    BarRect.left = DataRect.left + ( Width * Bar );
    BarRect.top = CurrentHeight + DataRect.top;
    BarRect.right = DataRect.left + Width * ( Bar + 1 );
    BarRect.bottom = BarRect.top - CurrentHeight;
    hBarBrush = CreateSolidBrush( Bars[Bar].Color );
    hOldBrush = SelectObject( TempDC, hBarBrush );
    Rectangle( TempDC, BarRect.left, BarRect.top, BarRect.right, BarRect.bottom );
    SelectObject( TempDC, hOldBrush );
    DeleteObject( hBarBrush );
    TempBars[Bar] = Bars[Bar];
    Wait();
}

/*************************************************************************/
/***                                                                   ***/
/**                             Results                                 **/
/***                                                                   ***/
/*************************************************************************/
BOOL FAR PASCAL __export ResultsProc( HWND hDlg, unsigned message, WORD wParam, LONG lParam )
{
    char String[10];

    switch( message ) 
    {
	    case WM_INITDIALOG:
	        if( Selection.Done ) 
	        {
	            sprintf( String, "%2.2f", Selection.Time );
	            SetDlgItemText( hDlg, ID_SELSEC, String );
	            SetDlgItemInt( hDlg, ID_SELSWP, Selection.Swaps, FALSE );
	            SetDlgItemInt( hDlg, ID_SELCOM, Selection.Compares, FALSE );
	        }
	        if( Insertion.Done ) 
	        {
	            sprintf( String, "%2.2f", Insertion.Time );
	            SetDlgItemText( hDlg, ID_INSSEC, String );
	            SetDlgItemInt( hDlg, ID_INSSWP, Insertion.Swaps, FALSE );
	            SetDlgItemInt( hDlg, ID_INSCOM, Insertion.Compares, FALSE );
	        }
	        if( Bubble.Done ) 
	        {
	            sprintf( String, "%2.2f", Bubble.Time );
	            SetDlgItemText( hDlg, ID_BUBSEC, String );
	            SetDlgItemInt( hDlg, ID_BUBSWP, Bubble.Swaps, FALSE );
	            SetDlgItemInt( hDlg, ID_BUBCOM, Bubble.Compares, FALSE );
	        }
	        if( Shell.Done ) 
	        {
	            sprintf( String, "%2.2f", Shell.Time );
	            SetDlgItemText( hDlg, ID_SHLSEC, String );
	            SetDlgItemInt( hDlg, ID_SHLSWP, Shell.Swaps, FALSE );
	            SetDlgItemInt( hDlg, ID_SHLCOM, Shell.Compares, FALSE );
	        }
	        if( Count.Done ) 
	        {
	            sprintf( String, "%2.2f", Count.Time );
	            SetDlgItemText( hDlg, ID_DCSEC, String );
	            SetDlgItemInt( hDlg, ID_DCSWP, Count.Swaps, FALSE );
	            SetDlgItemInt( hDlg, ID_DCCOM, Count.Compares, FALSE );
	        }
	        return TRUE;
	    case WM_COMMAND:
	        if( wParam == IDOK || wParam == IDCANCEL ) 
	        {
		        EndDialog( hDlg, TRUE );
		        return TRUE;
	        }
	        break;
    }
    return FALSE;
}

/*************************************************************************/
/***                                                                   ***/
/**                              Result                                 **/
/***                                                                   ***/
/*************************************************************************/
BOOL FAR PASCAL __export ResultProc( HWND hDlg, unsigned message, WORD wParam, LONG lParam )
{
    char String[50];

    switch( message ) 
    {
	    case WM_INITDIALOG:
        {
	        RESULT *SortResult;
	        
	        SortResult = ( RESULT* ) lParam;    
	    	strcpy( String, SortResult->Name );
	    	strcat( String, " sorting" );
	    	SetWindowText( hDlg, String );
	    	sprintf( String, "%2.2f", SortResult->Time );
	        SetDlgItemText( hDlg, ID_SEC, String );
	        SetDlgItemInt( hDlg, ID_SWP, SortResult->Swaps, FALSE );
	        SetDlgItemInt( hDlg, ID_COM, SortResult->Compares, FALSE );
	        return TRUE;
	    }
	    case WM_COMMAND:
	        if( wParam == IDOK || wParam == IDCANCEL ) 
	        {
		        EndDialog( hDlg, TRUE );
		        return TRUE;
	        }
	        break;
    }
    return FALSE;
}

/*************************************************************************/
/***                                                                   ***/
/**                          SelectionSort                              **/
/***                                                                   ***/
/*************************************************************************/
void SelectionSort()
{
    BAR Temp;
    int i, j, Min;
	clock_t Start, Finish;

	Selection.Swaps = Selection.Compares = 0;
	Start = clock();
    for( i = 0; i < BarsNum; i++ )
    {
        Min = i;
        for( j = i + 1; j < BarsNum; j++ )
        {
            Selection.Compares++;
            if( Bars[Min].Length > Bars[j].Length )
            	Min = j;
        }
		Selection.Swaps++;
		Temp = Bars[Min];
		Bars[Min] = Bars[i]; 
		DrawBar( Min );
		Bars[i] = Temp;
		DrawBar( i );
    }
    Finish = clock();
    Selection.Time = ( float ) ( Finish - Start ) / CLOCKS_PER_SEC;
    Selection.Done = TRUE;
}

/*************************************************************************/
/***                                                                   ***/
/**                          InsertionSort                              **/
/***                                                                   ***/
/*************************************************************************/
void InsertionSort()
{
    BAR Temp;
    int i, j, Length;
	clock_t Start, Finish;

	Insertion.Swaps = Insertion.Compares = 0;
	Start = clock();
    for( i = 0; i < BarsNum; i++ )
    {
        Temp = Bars[i];
        Length = Temp.Length;
        for( j = i; j > 0; j-- )
        {
            Insertion.Compares++;
            if( Bars[j - 1].Length > Length )
            {
                Insertion.Swaps++;
                Bars[j] = Bars[j - 1];
                DrawBar( j );
            }
            else             
                break;
        }
        Bars[j] = Temp;
        DrawBar( j );
    }
    Finish = clock();
    Insertion.Time = ( float ) ( Finish - Start ) / CLOCKS_PER_SEC;
    Insertion.Done = TRUE;
}

/*************************************************************************/
/***                                                                   ***/
/**                            BubbleSort                               **/
/***                                                                   ***/
/*************************************************************************/
void BubbleSort()
{
    BAR Temp;
    int i, j;
	clock_t Start, Finish;

	Bubble.Swaps = Bubble.Compares = 0;
	Start = clock();
    for( i = BarsNum - 1; i > 0; i-- )
    	for( j = 1; j <= i; j++ )
    	{	
    		Bubble.Compares++;
    		if( Bars[j-1].Length > Bars[j].Length )
    		{
    			Bubble.Swaps++;
    			Temp = Bars[j-1];
    			Bars[j-1] = Bars[j];
				DrawBar( j - 1 );
				Bars[j] = Temp;
				DrawBar( j );
    		}
    	}
    Finish = clock();
    Bubble.Time = ( float ) ( Finish - Start ) / CLOCKS_PER_SEC;
    Bubble.Done = TRUE;
}

/*************************************************************************/
/***                                                                   ***/
/**                             ShellSort                               **/
/***                                                                   ***/
/*************************************************************************/
void ShellSort()
{
    BAR Temp;
    int i, j, h, s;
	clock_t Start, Finish;

    Shell.Compares = Shell.Swaps = 0;
	Start = clock();
    h = BarsNum / 2;
    while( h )
    {
        j = BarsNum - h - 1;
        do
        {
            s = 0;
            for( i = 0; i <= j; i++ )
            {
                Shell.Compares++;
                if( Bars[i].Length > Bars[i + h].Length )
                {
	    			Shell.Swaps++;
	    			Temp = Bars[i];
	    			Bars[i] = Bars[i+h];
					DrawBar( i );
					Bars[i+h] = Temp;
					DrawBar( i + h );
                    s = i;
                }
            }
            j = s - h;
        } while( s );
        h = h / 2;
    }
    Finish = clock();
    Shell.Time = ( float ) ( Finish - Start ) / CLOCKS_PER_SEC;
    Shell.Done = TRUE;
}

/*************************************************************************/
/***                                                                   ***/
/**                             CountSort                               **/
/***                                                                   ***/
/*************************************************************************/
void CountSort()
{
    BAR TmpBars[MAXBARSNUM];
    int i;
	clock_t Start, Finish;

    Count.Compares = Count.Swaps = 0;
	Start = clock();
	for( i = 0; i < BarsNum; i++ )
		TmpBars[Bars[i].Length-1] = Bars[i];
	for( i = 0; i < BarsNum; i++ )
	{	
		Bars[i] = TmpBars[i];
		DrawBar( i );
	}
    Finish = clock();
    Count.Time = ( float ) ( Finish - Start ) / CLOCKS_PER_SEC;
    Count.Done = TRUE;
}

